## simutrans 124.3

=== CMakeLists.txt ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

cmake_minimum_required(VERSION 3.16)

# Disable in-source builds
if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
	message(FATAL_ERROR "Building Simutrans in-source is not supported. "
		"Please delete ${CMAKE_SOURCE_DIR}/CMakeCache.txt and configure in a different "
		"(preferrably empty) directory.")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

set(CMAKE_WARN_DEPRECATED ON)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/")

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransVcpkgTriplet.cmake)

project(simutrans LANGUAGES C CXX)

# Force C++14 everywhere
if(SIMUTRANS_STEAM_BUILT)
	set(CMAKE_CXX_STANDARD 17)
else()
	set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS OFF)

include(TestBigEndian)
TEST_BIG_ENDIAN(SIMUTRANS_BIG_ENDIAN)

if (MINGW)
	set(CMAKE_FIND_LIBRARY_SUFFIXES ".a" ON)
	set(CMAKE_EXE_LINKER_FLAGS "-static -static-libgcc -static-libstdc++")
endif ()

if (APPLE)
	list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/readline")
	link_directories(/usr/local/lib /opt/homebrew/lib)
	set(CMAKE_EXE_LINKER_FLAGS "-framework Cocoa")
endif ()


#
# Dependencies
#
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransFindDependencies.cmake)


#
# Configuration options
#
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransBackend.cmake) # Select backend (SDL2 / GDI)
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransCompileOptions.cmake)


# CMake does not fill in CMAKE_BUILD_TYPE automatically.
if (NOT MSVC)
	if (NOT DEFINED CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
		set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build type. Valid values are Debug Release MinSizeRel RelWithDebInfo" FORCE)
	endif ()
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo)
endif (NOT MSVC)


#
# sources
#
if(ANDROID)
	add_library(simutrans SHARED)
	target_link_libraries(simutrans PRIVATE android log)
	target_sources(simutrans PRIVATE src/android/android.cc)
else ()
	add_executable(simutrans MACOSX_BUNDLE)
endif ()
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
	set_target_properties(simutrans PROPERTIES WIN32_EXECUTABLE 1)
endif ()

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransSourceList.cmake)


#
# output directory
#
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/simutrans)
set_target_properties( simutrans PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/simutrans/$<0:> )


#
# Generate revision on compile time (so only if needed) if no revision is given
#
if (${SIMUTRANS_USE_REVISION})
	file(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/src/simutrans/revision.h "#define REVISION ${SIMUTRANS_USE_REVISION}\n")
	message(STATUS "Compiling Simutrans with manually specified revision ${SIMUTRANS_USE_REVISION}")
else ()
	string(FIND ${CMAKE_GENERATOR} "Visual Studio" VS )
	if (${VS} EQUAL 0)
		# using a script for MSVC project files
		file(WRITE ${CMAKE_CURRENT_SOURCE_DIR}/src/simutrans/revision.h "#define REVISION \n")
		add_custom_command(TARGET simutrans PRE_BUILD
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			COMMAND cscript.exe ARGS "/Nologo tools/revision.jse"
			COMMENT "Find SVN revision"
		)
	else ()
		# using custom target svnhear that is always built to update the revision.h file using cmake script
		add_custom_target(svnheader ALL DEPENDS svn_header)
		add_custom_command(OUTPUT svn_header COMMAND ${CMAKE_COMMAND} -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/SimutransRevision.cmake)
		set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/src/simutrans/revision.h PROPERTIES GENERATED TRUE HEADER_FILE_ONLY TRUE)
		add_dependencies(simutrans svnheader)
	endif ()
endif ()


#
# Documentation
#
find_package(Doxygen)

if (DOXYGEN_FOUND)
	if (DOXYGEN_HAVE_DOT)
		# DOXYGEN_DOT_PATH is deprecated, see
		# https://cmake.org/cmake/help/latest/module/FindDoxygen.html#variable:DOXYGEN_DOT_PATH
		get_target_property(graphviz_dot_executable doxygen::dot IMPORTED_LOCATION)
		get_filename_component(graphviz_dot_temp_dir ${GRAPHVIZ_DOT_EXE} DIRECTORY)
		file(TO_NATIVE_PATH "${graphviz_dot_temp_dir}" graphviz_dot_dir)
	endif ()

	configure_file(
		documentation/Doxyfile.in
		documentation/Doxyfile
		@ONLY
	)

	doxygen_add_docs(docs_simutrans
		CONFIG_FILE ${CMAKE_CURRENT_BINARY_DIR}/documentation/Doxyfile
	)

	add_custom_target(docs DEPENDS docs_simutrans)

	# The sqapi doxygen file depends on .sh shell scripts to filter files
	if (LINUX OR MINGW)
		configure_file(
			documentation/DoxyfileSQAPI.in
			documentation/DoxyfileSQAPI
			@ONLY
		)

		doxygen_add_docs(docs_sqapi
			CONFIG_FILE       ${CMAKE_CURRENT_BINARY_DIR}/documentation/DoxyfileSQAPI
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/simutrans/script/api/
		)

		add_dependencies(docs docs_sqapi)
	endif ()
endif ()


#
# Libraries
#

target_link_libraries(simutrans PRIVATE PNG::PNG)

if (WIN32)
	target_sources(simutrans PRIVATE src/Windows/simres.rc)
	target_sources(simutrans PRIVATE src/simutrans/sys/clipboard_w32.cc)
	target_link_libraries(simutrans PRIVATE ws2_32 winmm)

	# Backup sound and music routines if the selected backend does not provide any routines
	set(BACKUP_SOUND src/simutrans/sound/win32_sound_xa.cc)
	set(BACKUP_MUSIC src/simutrans/music/w32_midi.cc)
else ()
	if (SIMUTRANS_BACKEND STREQUAL "sdl2")
		target_sources(simutrans PRIVATE src/simutrans/sys/clipboard_s2.cc)
	else ()
		target_sources(simutrans PRIVATE src/simutrans/sys/clipboard_internal.cc)
	endif ()
	if (APPLE)
		#Darwin kernel version is used to identify macOS version (16->10.12/Sierra)
		if (CMAKE_HOST_SYSTEM_VERSION VERSION_GREATER_EQUAL 16) #AVF
			set(BACKUP_SOUND src/simutrans/sound/AVF_core-audio_sound.mm)
			#AVF MIDI currently crash Simutrans
			#set(BACKUP_MUSIC src/simutrans/music/AVF_core-audio_midi.mm)
			set(BACKUP_MUSIC src/simutrans/music/no_midi.cc)
		else () #QTKit
			set(BACKUP_SOUND src/simutrans/sound/core-audio_sound.mm)
			set(BACKUP_MUSIC src/simutrans/music/core-audio_midi.mm)
		endif ()
	else ()
		set(BACKUP_SOUND src/simutrans/sound/no_sound.cc)
		set(BACKUP_MUSIC src/simutrans/music/no_midi.cc)
	endif ()
endif ()

if (SIMUTRANS_MULTI_THREAD)
	target_compile_definitions(simutrans PRIVATE MULTI_THREAD=1)
	target_link_libraries(simutrans PRIVATE Threads::Threads)
endif (SIMUTRANS_MULTI_THREAD)

if (SIMUTRANS_BACKEND STREQUAL "sdl2")
	target_sources(simutrans PRIVATE src/simutrans/display/simgraph16.cc src/simutrans/sys/simsys_s2.cc src/simutrans/sound/sdl2_sound.cc)
	target_include_directories(simutrans PRIVATE ${SDL2_INCLUDE_DIRS})
	if (MINGW)
		target_link_libraries(simutrans PRIVATE ${SDL2_STATIC_LIBRARIES})
	elseif (APPLE)
		target_link_libraries(simutrans PRIVATE ${SDL2_LIBRARIES})
	elseif (MSVC)
		target_link_libraries(simutrans PRIVATE $<TARGET_NAME_IF_EXISTS:SDL2::SDL2main> $<IF:$<TARGET_EXISTS:SDL2::SDL2>,SDL2::SDL2,SDL2::SDL2-static>)
	elseif (ANDROID)
		target_link_libraries(simutrans PRIVATE SDL2 SDL2main)
	else ()
		target_link_libraries(simutrans PRIVATE PkgConfig::SDL2)
	endif ()
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=16)

elseif (SIMUTRANS_BACKEND STREQUAL "gdi")
	target_sources(simutrans PRIVATE src/simutrans/display/simgraph16.cc src/simutrans/sys/simsys_w.cc ${BACKUP_SOUND} )
	target_link_libraries(simutrans PRIVATE imm32 xaudio2_8)
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=16)

else ()
	if (NOT SIMUTRANS_BACKEND STREQUAL "none")
		message(WARNING "Unknown backend '${SIMUTRANS_BACKEND}', falling back to headless compilation")
	endif ()

	target_sources(simutrans PRIVATE src/simutrans/display/simgraph0.cc src/simutrans/sys/simsys_posix.cc src/simutrans/sound/no_sound.cc src/simutrans/music/no_midi.cc)
	target_compile_definitions(simutrans PRIVATE COLOUR_DEPTH=0)
endif ()


#
# Link dependencies
#
target_link_libraries(simutrans PRIVATE ZLIB::ZLIB)
target_link_libraries(simutrans PRIVATE BZip2::BZip2)

# Freetype is mandatory for graphical builds
if (SIMUTRANS_BACKEND STREQUAL "sdl2" OR SIMUTRANS_BACKEND STREQUAL "gdi")
	target_include_directories(simutrans PRIVATE ${Freetype_INCLUDE_DIRS})
	if (MINGW)
		target_link_libraries(simutrans PRIVATE ${Freetype_STATIC_LIBRARIES})
	elseif (APPLE)
		target_link_libraries(simutrans PRIVATE ${Freetype_LIBRARIES})
	elseif (MSVC OR ANDROID)
		target_link_libraries(simutrans PRIVATE Freetype::Freetype)
	else ()
		target_link_libraries(simutrans PRIVATE PkgConfig::Freetype)
	endif ()
	if (SIMUTRANS_USE_FONTCONFIG)
		target_compile_definitions(simutrans PRIVATE USE_FONTCONFIG=1)
		target_link_libraries(simutrans PRIVATE Fontconfig::Fontconfig)
	endif ()
endif ()

if (SIMUTRANS_USE_UPNP)
	target_compile_definitions(simutrans PRIVATE USE_UPNP=1)
	target_link_libraries(simutrans PRIVATE MiniUPNP::MiniUPNP)
endif (SIMUTRANS_USE_UPNP)

if (SIMUTRANS_USE_ZSTD)
	target_sources(simutrans PRIVATE src/simutrans/io/rdwr/zstd_file_rdwr_stream.cc)
	target_include_directories(simutrans PRIVATE ${ZSTD_INCLUDE_DIRS})
	target_compile_definitions(simutrans PRIVATE USE_ZSTD=1)
	if (MSVC)
		target_link_libraries(simutrans PRIVATE $<IF:$<TARGET_EXISTS:zstd::libzstd_shared>,zstd::libzstd_shared,zstd::libzstd_static>)
	elseif (MINGW)
		# only 64 bit cmake, 32 bit is broken
		target_link_libraries(simutrans PRIVATE -lzstd)
	elseif (ANDROID)
		target_link_libraries(simutrans PRIVATE ZSTD::ZSTD)
	else()
		target_link_libraries(simutrans PRIVATE PkgConfig::ZSTD)
	endif ()
endif (SIMUTRANS_USE_ZSTD)

# only consider FluidSynth for SDL2 and GDI backends
if ((SIMUTRANS_BACKEND STREQUAL "sdl2") OR (SIMUTRANS_BACKEND STREQUAL "gdi"))
	if (SIMUTRANS_USE_FLUIDSYNTH_MIDI)
		target_sources(simutrans PRIVATE src/simutrans/music/fluidsynth.cc src/simutrans/gui/loadsoundfont_frame.cc)
		target_compile_definitions(simutrans PRIVATE USE_FLUIDSYNTH_MIDI=1)
		if (MINGW)
			# since fluidsynth 2.2.2 fluidsynth.pc include static libraries, but some are still missing
			target_link_libraries(simutrans PRIVATE ${FluidSynth_STATIC_LIBRARIES} -liconv -lgomp)
		elseif (MSVC)
			target_link_libraries(simutrans PRIVATE FluidSynth::libfluidsynth)
		elseif (ANDROID)
			target_link_libraries(simutrans PRIVATE fluidsynth)
		else ()
			target_link_libraries(simutrans PRIVATE PkgConfig::FluidSynth)
		endif (MINGW)
	else ()
		target_sources( simutrans PRIVATE ${BACKUP_MUSIC} )
	endif (SIMUTRANS_USE_FLUIDSYNTH_MIDI)
endif ((SIMUTRANS_BACKEND STREQUAL "sdl2") OR (SIMUTRANS_BACKEND STREQUAL "gdi"))

if (SIMUTRANS_STEAM_BUILT AND NOT ANDROID)
	target_compile_definitions(simutrans PRIVATE STEAM_BUILT=1)
	target_sources(simutrans PRIVATE src/steam/steam.cc src/steam/workshop_item.cc src/steam/achievements.cc )
	add_library(steam SHARED IMPORTED)
	if(APPLE)
		set_target_properties(steam PROPERTIES IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/osx/libsteam_api.dylib)
	elseif(UNIX)
		set_target_properties(steam PROPERTIES IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/linux64/libsteam_api.so)
	elseif(MSVC AND CMAKE_GENERATOR_PLATFORM MATCHES "x64")
		set_target_properties(steam PROPERTIES IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/win64/steam_api64.dll)
		set_target_properties(steam PROPERTIES IMPORTED_IMPLIB ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/win64/steam_api64.lib)
	else(MSVC AND CMAKE_GENERATOR_PLATFORM MATCHES "Win32")
		set_target_properties(steam PROPERTIES IMPORTED_LOCATION ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/steam_api.dll)
		set_target_properties(steam PROPERTIES IMPORTED_IMPLIB ${CMAKE_SOURCE_DIR}/sdk/redistributable_bin/steam_api.lib)
	endif()
	target_include_directories(simutrans PRIVATE ${CMAKE_SOURCE_DIR}/sdk/public/steam)
	target_link_libraries(simutrans PRIVATE steam)
endif ()

#
# compile options
#
if (MSVC)
	target_link_options(simutrans PRIVATE /INCREMENTAL:NO /NODEFAULTLIB:LIBCMTD /MANIFEST:NO /LARGEADDRESSAWARE)
endif ()

if (SIMUTRANS_BIG_ENDIAN)

=== Makefile ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

# Define variables here to force them as simple flavor. -> Faster parallel builds.
FLAGS :=
CFLAGS ?=
LDFLAGS ?=
LIBS :=
SOURCES :=
STATIC := 0

DYNAMICSTART =
DYNAMICEND =

CFG ?= default
-include config.$(CFG)


HOSTCC  ?=$(CC)
HOSTCXX ?=$(CXX)

SDL2_CONFIG      ?= pkg-config sdl2
#SDL2_CONFIG     ?= sdl2-config
FREETYPE_CONFIG  ?= pkg-config freetype2
# FREETYPE_CONFIG ?= freetype-config
FONTCONFIG_CONFIG  ?= pkg-config fontconfig

BACKENDS  := gdi sdl2 mixer_sdl2 posix
OSTYPES   := amiga freebsd haiku linux mac mingw openbsd


ifeq ($(findstring $(BACKEND), $(BACKENDS)),)
  $(error Unkown BACKEND "$(BACKEND)", must be one of "$(BACKENDS)")
endif

ifeq ($(findstring $(OSTYPE), $(OSTYPES)),)
  $(error Unkown OSTYPE "$(OSTYPE)", must be one of "$(OSTYPES)")
endif

ifeq ($(BACKEND),posix)
  COLOUR_DEPTH := 0
else
  COLOUR_DEPTH := 16
endif

# since threads are needed to be linked dynamically on most systems
ifdef MULTI_THREAD
  ifeq ($(shell expr $(MULTI_THREAD) \>= 1), 1)
    CFLAGS += -DMULTI_THREAD
    ifneq ($(OSTYPE),mingw)
      ifneq ($(OSTYPE),haiku)
        # mingw has already added pthread statically
        ifneq ($(OSTYPE),mingw)
          LDFLAGS += -lpthread
        endif
      endif
    endif
  else
    ifneq ($(OSTYPE),mingw)
      ifeq ($(BACKEND),sdl2)
        LDFLAGS += -lpthread
      endif
      ifeq ($(BACKEND),mixer_sdl2)
        LDFLAGS += -lpthread
      endif
    endif
  endif
endif

ifeq ($(OSTYPE),amiga)
  STD_LIBS ?= -lunix -lSDL_mixer -lsmpeg -lvorbisfile -lvorbis -logg
  CFLAGS   += -mcrt=newlib -DSIM_BIG_ENDIAN -gstabs+
  LDFLAGS  += -Bstatic -non_shared
else ifeq ($(OSTYPE),beos)
  # BeOS (obsolete)
  LIBS += -lnet
else ifeq ($(OSTYPE),freebsd)
  CFLAGS  += -I/usr/local/include
else ifeq ($(OSTYPE),haiku)
  # Haiku (needs to activate the GCC 4x)
  LIBS += -lnetwork -lbe
else ifeq ($(OSTYPE),mingw)
  CFLAGS    += -DPNG_STATIC -DZLIB_STATIC
  ifeq ($(shell expr $(STATIC) \>= 1), 1)
    CFLAGS  += -static
    LDFLAGS += -static-libgcc -static-libstdc++ -static
  endif
  ifeq ($(MINGW_PACKAGE_PREFIX),mingw-w64-i686)
    LDFLAGS   += -Wl,--large-address-aware
  endif
  LDFLAGS   += -pthread
  CFLAGS    += -Wno-deprecated-copy -DNOMINMAX -DWIN32_LEAN_AND_MEAN -DWINVER=0x0501 -D_WIN32_IE=0x0500
  LIBS      += -lmingw32 -lgdi32 -lwinmm -lws2_32 -limm32

  # Disable the console on Windows unless WIN32_CONSOLE is set or graphics are disabled
  ifdef WIN32_CONSOLE
    ifeq ($(shell expr $(WIN32_CONSOLE) \>= 1), 1)
      LDFLAGS += -mconsole
    endif
  else ifeq ($(BACKEND),posix)
    LDFLAGS += -mconsole
  else
    LDFLAGS += -mwindows
  endif
else ifeq ($(OSTYPE),linux)
  ifeq ($(shell expr $(STATIC) \>= 1), 1)
    LDFLAGS +=  -Wl,-Bstatic -lm
    DYNAMICSTART = -Wl,-Bdynamic 
    DYNAMICEND = -Wl,-Bstatic 
  endif
else ifeq ($(OSTYPE),mac)
  LDFLAGS += -framework Cocoa
endif

ifeq ($(BACKEND),sdl2)
  SOURCES += src/simutrans/sys/clipboard_s2.cc
else ifeq ($(OSTYPE),mingw)
  SOURCES += src/simutrans/sys/clipboard_w32.cc
else
  SOURCES += src/simutrans/sys/clipboard_internal.cc
endif

LIBS += -lbz2 -lz -lpng

ifdef OPTIMISE
  ifeq ($(shell expr $(OPTIMISE) \>= 1), 1)
    CFLAGS += -O3
    ifeq ($(findstring amiga, $(OSTYPE)),)
      ifneq ($(findstring clang, $(CXX)),)
        CFLAGS += -minline-all-stringops
      endif
    endif
  endif
else
  CFLAGS += -O1
endif

ifneq ($(LTO),)
  CFLAGS += -flto
  LDFLAGS += -flto
endif

ifdef DEBUG
  MSG_LEVEL ?= 3
  PROFILE ?= 0

  ifeq ($(shell expr $(DEBUG) \>= 1), 1)
    CFLAGS   += -g -DDEBUG
  endif

  ifeq ($(shell expr $(DEBUG) \>= 2), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline
    endif
  endif

  ifeq ($(shell expr $(DEBUG) \>= 3), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -O0
    endif
  endif
else
  CFLAGS += -DNDEBUG
endif

ifdef MSG_LEVEL
  CFLAGS += -DMSG_LEVEL=$(MSG_LEVEL)
endif

ifneq ($(BACKEND),posix)
  ifneq ($(FREETYPE_CONFIG),)
    CFLAGS += $(shell $(FREETYPE_CONFIG) --cflags)
    ifeq ($(shell expr $(STATIC) \>= 1), 1)
      # since static is not supported by slightly old freetype versions
      FTF := $(shell $(FREETYPE_CONFIG) --libs --static)
      ifneq ($(FTF),)
        LDFLAGS += $(subst -lm ,,$(FTF))
      else
        LDFLAGS += $(shell $(FREETYPE_CONFIG) --libs)
      endif
    else
      LDFLAGS   += $(shell $(FREETYPE_CONFIG) --libs)
    endif
  else
    LDFLAGS += -lfreetype
    ifeq ($(OSTYPE),mingw)
      LDFLAGS += -lpng -lharfbuzz
    endif
  endif
  
  ifeq ($(OSTYPE),mingw)
    LDFLAGS += -lfreetype
  endif

  ifdef USE_FONTCONFIG
    ifeq ($(shell expr $(USE_FONTCONFIG) \>= 1), 1)
      sdfsfsd := $(shell echo error)
      CFLAGS  += -DUSE_FONTCONFIG
      CFLAGS  += $(shell $(FONTCONFIG_CONFIG) --cflags)
      LDFLAGS += $(shell $(FONTCONFIG_CONFIG) --libs)
    endif
  endif
endif

ifdef USE_UPNP
  ifeq ($(shell expr $(USE_UPNP) \>= 1), 1)
    CFLAGS      += -DUSE_UPNP
    LDFLAGS     += -lminiupnpc
    ifeq ($(OSTYPE),mingw)
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bdynamic
      endif
      LDFLAGS   += -liphlpapi
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bstatic
      endif
    endif
  endif
endif

ifdef USE_ZSTD
  ifeq ($(shell expr $(USE_ZSTD) \>= 1), 1)
    CFLAGS  += -DUSE_ZSTD
    LDFLAGS += -lzstd
    SOURCES += src/simutrans/io/rdwr/zstd_file_rdwr_stream.cc
  endif
endif

ifdef USE_FLUIDSYNTH_MIDI
  ifeq ($(shell expr $(USE_FLUIDSYNTH_MIDI) \>= 1), 1)
    CFLAGS  += -DUSE_FLUIDSYNTH_MIDI
    SOURCES += src/simutrans/music/fluidsynth.cc
    SOURCES += src/simutrans/gui/loadsoundfont_frame.cc
    LDFLAGS += $(DYNAMICSTART)-lfluidsynth $(DYNAMICEND)
    ifeq ($(OSTYPE),mingw)
      # fluidsynth.pc doesn't properly list dependant libraries, unable to use pkg-config. Manually listed below. Only valid for fluidsynth built with options: "-DBUILD_SHARED_LIBS=0 -Denable-aufile=0 -Denable-dbus=0 -Denable-ipv6=0 -Denable-jack=0 -Denable-ladspa=0 -Denable-midishare=0 -Denable-opensles=0 -Denable-oboe=0 -Denable-oss=0 -Denable-readline=0 -Denable-winmidi=0 -Denable-waveout=0 -Denable-libsndfile=0 -Denable-network=0 -Denable-pulseaudio=0 Denable-dsound=1 -Denable-sdl2=0"
      LDFLAGS += -lglib-2.0 -lintl -liconv -ldsound -lole32
    else
    endif
  endif
else
  USE_FLUIDSYNTH_MIDI := 0
endif

ifdef PROFILE
  ifeq ($(shell expr $(PROFILE) \>= 1), 1)
    CFLAGS   += -pg -DPROFILE
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline

      ifeq ($(findstring clang, $(CXX)),)
        CFLAGS += -fno-schedule-insns
      endif
    endif
    LDFLAGS  += -pg
  endif
endif

ifdef WITH_REVISION
  ifeq ($(shell expr $(WITH_REVISION) \>= 1), 1)
    ifeq ($(shell expr $(WITH_REVISION) \>= 2), 1)
      REV := $(WITH_REVISION)
    else
      REV := $(shell tools/get_revision.sh)
      $(info Revision is $(REV))
    endif
  endif
endif

ifneq ($(REV),)
  CFLAGS  += -DREVISION=$(REV)
  DUMMY := $(shell rm -f src/simutrans/revision.h)
else
  ifeq ("$(wildcard src/simutrans/revision.h)","")
    DUMMY := $(shell printf '#define REVISION' > src/simutrans/revision.h)
  endif
endif


ifneq ($(GIT_HASH),)
  GIT_HASH := $(shell git rev-parse --short=7 HEAD)
  ifeq ($(.SHELLSTATUS),0)
    $(info Git hash is 0x$(GIT_HASH))
    CFLAGS  += -DGIT_HASH=0x$(GIT_HASH)
  endif
endif


CFLAGS   += -Wall -Wextra -Wcast-qual -Wpointer-arith -Wcast-align $(FLAGS)
CCFLAGS  += -ansi -Wstrict-prototypes -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64


# sources (in alphabetic order)
SOURCES += src/simutrans/builder/brueckenbauer.cc
SOURCES += src/simutrans/builder/fabrikbauer.cc
SOURCES += src/simutrans/builder/goods_manager.cc
SOURCES += src/simutrans/builder/hausbauer.cc
SOURCES += src/simutrans/builder/tree_builder.cc
SOURCES += src/simutrans/builder/tunnelbauer.cc
SOURCES += src/simutrans/builder/vehikelbauer.cc
SOURCES += src/simutrans/builder/wegbauer.cc
SOURCES += src/simutrans/dataobj/crossing_logic.cc
SOURCES += src/simutrans/dataobj/environment.cc
SOURCES += src/simutrans/dataobj/freelist.cc
SOURCES += src/simutrans/dataobj/gameinfo.cc
SOURCES += src/simutrans/dataobj/height_map_loader.cc
SOURCES += src/simutrans/dataobj/koord.cc
SOURCES += src/simutrans/dataobj/koord3d.cc
SOURCES += src/simutrans/dataobj/loadsave.cc
SOURCES += src/simutrans/dataobj/marker.cc
SOURCES += src/simutrans/dataobj/objlist.cc
SOURCES += src/simutrans/dataobj/pakset_manager.cc
SOURCES += src/simutrans/dataobj/pakset_downloader.cc
SOURCES += src/simutrans/dataobj/powernet.cc
SOURCES += src/simutrans/dataobj/records.cc
SOURCES += src/simutrans/dataobj/rect.cc
SOURCES += src/simutrans/dataobj/ribi.cc
SOURCES += src/simutrans/dataobj/route.cc
SOURCES += src/simutrans/dataobj/scenario.cc
SOURCES += src/simutrans/dataobj/schedule.cc
SOURCES += src/simutrans/dataobj/settings.cc
SOURCES += src/simutrans/dataobj/sve_cache.cc
SOURCES += src/simutrans/dataobj/tabfile.cc
SOURCES += src/simutrans/dataobj/translator.cc
SOURCES += src/simutrans/descriptor/bridge_desc.cc
SOURCES += src/simutrans/descriptor/building_desc.cc
SOURCES += src/simutrans/descriptor/factory_desc.cc
SOURCES += src/simutrans/descriptor/goods_desc.cc
SOURCES += src/simutrans/descriptor/ground_desc.cc
SOURCES += src/simutrans/descriptor/image.cc
SOURCES += src/simutrans/descriptor/obj_base_desc.cc
SOURCES += src/simutrans/descriptor/reader/bridge_reader.cc
SOURCES += src/simutrans/descriptor/reader/building_reader.cc
SOURCES += src/simutrans/descriptor/reader/citycar_reader.cc
SOURCES += src/simutrans/descriptor/reader/crossing_reader.cc
SOURCES += src/simutrans/descriptor/reader/factory_reader.cc
SOURCES += src/simutrans/descriptor/reader/good_reader.cc
SOURCES += src/simutrans/descriptor/reader/ground_reader.cc
SOURCES += src/simutrans/descriptor/reader/groundobj_reader.cc
SOURCES += src/simutrans/descriptor/reader/image_reader.cc
SOURCES += src/simutrans/descriptor/reader/imagelist2d_reader.cc
SOURCES += src/simutrans/descriptor/reader/imagelist_reader.cc
SOURCES += src/simutrans/descriptor/reader/obj_reader.cc
SOURCES += src/simutrans/descriptor/reader/pedestrian_reader.cc
SOURCES += src/simutrans/descriptor/reader/roadsign_reader.cc
SOURCES += src/simutrans/descriptor/reader/root_reader.cc
SOURCES += src/simutrans/descriptor/reader/sim_reader.cc
SOURCES += src/simutrans/descriptor/reader/skin_reader.cc
SOURCES += src/simutrans/descriptor/reader/sound_reader.cc
SOURCES += src/simutrans/descriptor/reader/text_reader.cc
SOURCES += src/simutrans/descriptor/reader/tree_reader.cc
SOURCES += src/simutrans/descriptor/reader/tunnel_reader.cc
SOURCES += src/simutrans/descriptor/reader/vehicle_reader.cc
SOURCES += src/simutrans/descriptor/reader/way_obj_reader.cc
SOURCES += src/simutrans/descriptor/reader/way_reader.cc
SOURCES += src/simutrans/descriptor/reader/xref_reader.cc
SOURCES += src/simutrans/descriptor/sound_desc.cc
SOURCES += src/simutrans/descriptor/tunnel_desc.cc
SOURCES += src/simutrans/descriptor/vehicle_desc.cc
SOURCES += src/simutrans/descriptor/way_desc.cc
SOURCES += src/simutrans/display/font.cc
SOURCES += src/simutrans/display/simgraph$(COLOUR_DEPTH).cc
SOURCES += src/simutrans/display/simview.cc
SOURCES += src/simutrans/display/viewport.cc
SOURCES += src/simutrans/freight_list_sorter.cc
SOURCES += src/simutrans/ground/boden.cc
SOURCES += src/simutrans/ground/brueckenboden.cc
SOURCES += src/simutrans/ground/fundament.cc
SOURCES += src/simutrans/ground/grund.cc
SOURCES += src/simutrans/ground/monorailboden.cc
SOURCES += src/simutrans/ground/tunnelboden.cc
SOURCES += src/simutrans/ground/wasser.cc
SOURCES += src/simutrans/gui/components/gui_aligned_container.cc
SOURCES += src/simutrans/gui/components/gui_building.cc
SOURCES += src/simutrans/gui/components/gui_button.cc
SOURCES += src/simutrans/gui/components/gui_button_to_chart.cc
SOURCES += src/simutrans/gui/components/gui_chart.cc

=== src/makeobj/CMakeLists.txt ===
#
# This file is part of the Simutrans project under the artistic licence.
# (see licence.txt)
#

add_executable(makeobj
	makeobj.cc
)

target_compile_options(makeobj PRIVATE ${SIMUTRANS_COMMON_COMPILE_OPTIONS})
target_compile_definitions(makeobj PRIVATE MAKEOBJ=1 COLOUR_DEPTH=0)
target_compile_definitions(makeobj PRIVATE MSG_LEVEL=${SIMUTRANS_MSG_LEVEL})

if (SIMUTRANS_USE_SYSLOG)
	target_compile_definitions(simutrans PRIVATE SYSLOG=1)
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 4 AND SIMUTRANS_BUILD_32BIT)
	target_compile_options(makeobj PRIVATE -m32)
	set_target_properties(makeobj PROPERTIES LINK_FLAGS "-m32")
endif ()

target_link_libraries(makeobj
	PNG::PNG
)


# These source files are unique to makeobj
target_sources(makeobj PRIVATE
	../simutrans/descriptor/writer/bridge_writer.cc
	../simutrans/descriptor/writer/building_writer.cc
	../simutrans/descriptor/writer/citycar_writer.cc
	../simutrans/descriptor/writer/crossing_writer.cc
	../simutrans/descriptor/writer/factory_writer.cc
	../simutrans/descriptor/writer/get_climate.cc
	../simutrans/descriptor/writer/get_waytype.cc
	../simutrans/descriptor/writer/good_writer.cc
	../simutrans/descriptor/writer/groundobj_writer.cc
	../simutrans/descriptor/writer/ground_writer.cc
	../simutrans/descriptor/writer/image_writer.cc
	../simutrans/descriptor/writer/imagelist2d_writer.cc
	../simutrans/descriptor/writer/imagelist_writer.cc
	../simutrans/descriptor/writer/obj_node.cc
	../simutrans/descriptor/writer/obj_writer.cc
	../simutrans/descriptor/writer/pedestrian_writer.cc
	../simutrans/descriptor/writer/roadsign_writer.cc
	../simutrans/descriptor/writer/root_writer.cc
	../simutrans/descriptor/writer/sim_writer.cc
	../simutrans/descriptor/writer/skin_writer.cc
	../simutrans/descriptor/writer/sound_writer.cc
	../simutrans/descriptor/writer/text_writer.cc
	../simutrans/descriptor/writer/tree_writer.cc
	../simutrans/descriptor/writer/tunnel_writer.cc
	../simutrans/descriptor/writer/vehicle_writer.cc
	../simutrans/descriptor/writer/way_writer.cc
	../simutrans/descriptor/writer/way_obj_writer.cc
	../simutrans/descriptor/writer/xref_writer.cc
)

# These source files produce the same object code in makeobj and simutrans
target_sources(makeobj PRIVATE
	../simutrans/descriptor/image.cc
	../simutrans/dataobj/freelist.cc
	../simutrans/io/raw_image.cc
	../simutrans/simio.cc
	../simutrans/simdebug.cc
	../simutrans/simmem.cc
	../simutrans/utils/simstring.cc
	../simutrans/utils/searchfolder.cc
)

# These source files produce different object code in makeobj and simutrans
target_sources(makeobj PRIVATE
	../simutrans/dataobj/tabfile.cc
	../simutrans/io/classify_file.cc
	../simutrans/io/raw_image_bmp.cc
	../simutrans/io/raw_image_png.cc
	../simutrans/io/raw_image_ppm.cc
	../simutrans/utils/log.cc
)

=== src/makeobj/Makefile ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

CFG ?= default
-include ../../config.$(CFG)

OSTYPES = beos cygwin freebsd haiku linux mingw mac

ifeq ($(findstring $(OSTYPE), $(OSTYPES)),)
  $(error Unkown OSTYPE "$(OSTYPE)", must be one of "$(OSTYPES)")
endif

PNG_CONFIG ?= pkg-config libpng

ifneq ($(PNG_CONFIG),)
	PNG_CFLAGS  := $(shell $(PNG_CONFIG) --cflags)
	PNG_LDFLAGS := $(shell $(PNG_CONFIG) --libs)
endif

CFLAGS  += $(PNG_CFLAGS)
LDFLAGS += $(PNG_LDFLAGS)

# Absolutely essential
CXXFLAGS += -DMAKEOBJ

STD_LIBS += -lz -lbz2 -lpng

ifeq ($(OSTYPE),cygwin)
  OS_INC   ?= -I/usr/include/mingw
  OS_OPT   ?= -mwin32
  STD_LIBS += -lwinmm
endif

ifeq ($(OSTYPE),mingw)
  OS_OPT   ?= -DPNG_STATIC -DZLIB_STATIC -march=pentium
  LDFLAGS += -static-libgcc -static-libstdc++ -static
  # we need the libraries EXACTLY in this order to link
  STD_LIBS = -lmingw32 -lpng -lz
endif

ifeq ($(OSTYPE),mac)
  CXXFLAGS   += -DUSE_HW -DUSE_C
endif

ifeq ($(OSTYPE),freebsd)
  CXXFLAGS += -I/usr/local/include
endif

ifdef OPTIMISE
  ifeq ($(shell expr $(OPTIMISE) \>= 1), 1)
    CXXFLAGS += -O3

    # clang does not support fno-schedule-insns
    ifeq ($(findstring clang, $(CXX)),)
      CXXFLAGS += -fno-schedule-insns
    endif
  endif
else
  CXXFLAGS += -O
endif

ifdef DEBUG
  ifeq ($(shell expr $(DEBUG) \>= 1), 1)
    CXXFLAGS += -g -DDEBUG
  endif
  ifeq ($(shell expr $(DEBUG) \>= 2), 1)
    CXXFLAGS += -fno-inline
  endif
  ifeq ($(shell expr $(DEBUG) \>= 3), 1)
    CXXFLAGS += -O0
  endif
else
  CXXFLAGS += -DNDEBUG
endif

ifdef PROFILE
  ifeq ($(shell expr $(PROFILE) \>= 1), 1)
    CXXFLAGS += -pg -DPROFILE -fno-inline
    LDFLAGS += -pg
  endif
endif

CXXFLAGS += -DREVISION -Wall -Wextra -Wcast-qual -Wpointer-arith -Wcast-align $(OS_INC) $(OS_OPT) $(FLAGS)

# SOLO_SOURCES contains files which are unique to makeobj;
# SHARED_SOURCES contains those with the exact same object code in makeobj and simutrans;
# VARIANT_SOURCES contains those which need different .o files for makeobj and simutrans.
# At the moment they're all treated identically, of course.
SOLO_SOURCES += makeobj.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/bridge_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/building_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/citycar_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/crossing_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/factory_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/get_climate.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/get_waytype.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/good_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/groundobj_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/ground_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/image_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/imagelist2d_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/imagelist_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/obj_node.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/obj_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/pedestrian_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/roadsign_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/root_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/sim_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/skin_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/sound_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/text_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/tree_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/tunnel_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/vehicle_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/way_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/way_obj_writer.cc
SOLO_SOURCES += ../simutrans/descriptor/writer/xref_writer.cc
SHARED_SOURCES += ../simutrans/descriptor/image.cc
SHARED_SOURCES += ../simutrans/dataobj/freelist.cc
SHARED_SOURCES += ../simutrans/io/raw_image.cc
SHARED_SOURCES += ../simutrans/simio.h
SHARED_SOURCES += ../simutrans/simdebug.cc
SHARED_SOURCES += ../simutrans/simmem.cc
SHARED_SOURCES += ../simutrans/utils/simstring.cc
SHARED_SOURCES += ../simutrans/utils/searchfolder.cc
VARIANT_SOURCES += ../simutrans/dataobj/tabfile.cc
VARIANT_SOURCES += ../simutrans/io/classify_file.cc
VARIANT_SOURCES += ../simutrans/io/raw_image_bmp.cc
VARIANT_SOURCES += ../simutrans/io/raw_image_png.cc
VARIANT_SOURCES += ../simutrans/io/raw_image_ppm.cc
VARIANT_SOURCES += ../simutrans/utils/log.cc

SOURCES ?= $(SOLO_SOURCES) $(SHARED_SOURCES) $(VARIANT_SOURCES)

BUILDDIR ?= build/$(CFG)
TOOL  = makeobj
PROG ?= makeobj

ifeq ($(origin MAKEOBJ_PROGDIR), undefined)
  MAKEOBJ_PROGDIR := ../../$(BUILDDIR)/$(TOOL)
endif

BUILDDIR := ../../$(BUILDDIR)

TOOL_PROGDIR = $(MAKEOBJ_PROGDIR)

include ../../uncommon.mk

=== src/nettool/CMakeLists.txt ===
#
# This file is part of the Simutrans project under the artistic licence.
# (see licence.txt)
#

add_executable(nettool
	nettool.cc
)

target_compile_options(nettool PRIVATE ${SIMUTRANS_COMMON_COMPILE_OPTIONS})
target_compile_definitions(nettool PRIVATE NETTOOL=1 COLOUR_DEPTH=0)
target_compile_definitions(nettool PRIVATE MSG_LEVEL=${SIMUTRANS_MSG_LEVEL})

if (SIMUTRANS_USE_SYSLOG)
	target_compile_definitions(nettool PRIVATE SYSLOG=1)
endif ()

if (NOT SIMUTRANS_USE_IPV6)
	target_compile_definitions(nettool PRIVATE USE_IP4_ONLY=1)
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 4 AND SIMUTRANS_BUILD_32BIT)
	target_compile_options(nettool PRIVATE -m32)
	set_target_properties(nettool PROPERTIES LINK_FLAGS "-m32")
endif ()

# these source files produce the same object code in nettool and simutrans
target_sources(nettool PRIVATE
	../simutrans/dataobj/freelist.cc
	../simutrans/network/memory_rw.cc
	../simutrans/network/network_address.cc
	../simutrans/network/network_cmd.cc
	../simutrans/network/network_packet.cc
	../simutrans/network/network_socket_list.cc
	../simutrans/simdebug.cc
	../simutrans/simmem.cc
	../simutrans/utils/simstring.cc
	../simutrans/utils/fetchopt.cc
	../simutrans/utils/sha1.cc
	../simutrans/utils/sha1_hash.cc
)

# these source files produce different object code in nettool and simutrans
target_sources(nettool PRIVATE
	../simutrans/utils/log.cc
	../simutrans/network/network.cc
	../simutrans/network/network_file_transfer.cc
)

if (WIN32)
	target_link_libraries(nettool PRIVATE ws2_32)
endif (WIN32)

=== src/nettool/Makefile ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

CFG ?= default
-include ../../config.$(CFG)

OSTYPES       = beos cygwin freebsd haiku linux mingw mac

ifeq ($(findstring $(OSTYPE), $(OSTYPES)),)
  $(error Unkown OSTYPE "$(OSTYPE)", must be one of "$(OSTYPES)")
endif

# Absolutely essential
CXXFLAGS += -DNETTOOL

ifeq ($(OSTYPE),cygwin)
  OS_INC   ?= -I/usr/include/mingw
  OS_OPT   ?= -mwin32
  STD_LIBS += -lwinmm -lcurses
endif

ifeq ($(OSTYPE),mingw)
  CC ?= gcc
  OS_OPT   ?= -march=pentium
  # we need the libraries EXACTLY in this order to link
  STD_LIBS = -lmingw32 -lstdc++ -lws2_32
endif

ifeq ($(OSTYPE),mac)
  CXXFLAGS   += -DUSE_HW -DUSE_C
endif

ifdef OPTIMISE
  ifeq ($(shell expr $(OPTIMISE) \>= 1), 1)
    CXXFLAGS += -O3

    # clang does not support fno-schedule-insns
    ifeq ($(findstring clang, $(CXX)),)
      CXXFLAGS += -fno-schedule-insns
    endif
  endif
else
  CXXFLAGS += -O
endif

ifdef DEBUG
  ifeq ($(shell expr $(DEBUG) \>= 1), 1)
    CXXFLAGS += -g -DDEBUG
  endif
  ifeq ($(shell expr $(DEBUG) \>= 2), 1)
    CXXFLAGS += -fno-inline
  endif
  ifeq ($(shell expr $(DEBUG) \>= 3), 1)
    CXXFLAGS += -O0
  endif
else
  CXXFLAGS += -DNDEBUG
endif

ifdef PROFILE
  ifeq ($(shell expr $(PROFILE) \>= 1), 1)
    CXXFLAGS += -pg -DPROFILE -fno-inline
    LDFLAGS += -pg
  endif
endif

CXXFLAGS += -DREVISION -Wall -Wextra -Wcast-qual -Wpointer-arith -Wcast-align $(OS_INC) $(OS_OPT) $(FLAGS)

# SOLO_SOURCES contains files which are unique to nettool;
# SHARED_SOURCES contains those with the exact same object code in nettool and simutrans;
# VARIANT_SOURCES contains those which need different .o files for nettool and simutrans.
# At the moment they're all treated identically, of course.
SOLO_SOURCES += nettool.cc
SHARED_SOURCES += ../simutrans/dataobj/freelist.cc
SHARED_SOURCES += ../simutrans/network/memory_rw.cc
SHARED_SOURCES += ../simutrans/network/network_address.cc
SHARED_SOURCES += ../simutrans/network/network_cmd.cc
SHARED_SOURCES += ../simutrans/network/network_packet.cc
SHARED_SOURCES += ../simutrans/network/network_socket_list.cc
SHARED_SOURCES += ../simutrans/simdebug.cc
SHARED_SOURCES += ../simutrans/simmem.cc
SHARED_SOURCES += ../simutrans/utils/simstring.cc
SHARED_SOURCES += ../simutrans/utils/fetchopt.cc
SHARED_SOURCES += ../simutrans/utils/sha1.cc
SHARED_SOURCES += ../simutrans/utils/sha1_hash.cc
VARIANT_SOURCES += ../simutrans/utils/log.cc
VARIANT_SOURCES += ../simutrans/network/network.cc
VARIANT_SOURCES += ../simutrans/network/network_file_transfer.cc

SOURCES ?= $(SOLO_SOURCES) $(SHARED_SOURCES) $(VARIANT_SOURCES)

BUILDDIR ?= build/$(CFG)
TOOL  = nettool
PROG ?= nettool

ifeq ($(origin NETTOOL_PROGDIR), undefined)
  NETTOOL_PROGDIR := ../../$(BUILDDIR)/$(TOOL)
endif

BUILDDIR := ../../$(BUILDDIR)

TOOL_PROGDIR = $(NETTOOL_PROGDIR)

include ../../uncommon.mk

=== debian/changelog ===
simutrans (124.3-2build1) resolute; urgency=medium

  * Rebuild against latest miniupnpc

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 29 Oct 2025 15:49:34 -0400

simutrans (124.3-2) unstable; urgency=medium

  * Team Upload
  * Clean better (Closes: #1045991)
  * Remove obsolete dependency on quilt
  * Reformat d/control with debputy

 -- Alexandre Detiste <tchet@debian.org>  Mon, 17 Mar 2025 17:01:17 +0100

simutrans (124.3-1) unstable; urgency=medium

  * Team Upload

  [ Jörg Frings-Fürst ]
  * New debian/patches/0115-fix_miniupnpc.patch (Closes: #1076693):
    - Fix FTBFS with miniupnpc 2.2.8.
      Thanks to Yangfl <mmyangfl@gmail.com>.
  * debian/copyright:
    - Add year 2024 to myself.
  * Declare compliance with Debian Policy 4.7.0 (No changes needed).
  * debian/rules:
    + Fix FTCBFS: uses build architecture build tools (Closes: #1038715).
      Thanks to Helmut Grohne <helmut@subdivi.de>.
  * Add debian/salsa-ci.yml to enable some tests.
  *  Datei .gitlab-ci.yml aktualisieren

  [ Patrice Duroux ]
  * d/watch: use github
  * New upstream version 124.3 (Closes: #1087201)
  * d/copyright: use https, bump year, refresh file paths
  * d/control: use https in homepage
  * d/simutrans.xpm: remove (upstream provides svg)
  * d/control: add libfontconfig-dev and pkgconf to BD
  * d/rules: use cmake
  * d/*.dirs: remove all and refresh d/*.install
  * d/translations: removed (upstream have?)
  * d/patches: clean up

 -- Alexandre Detiste <tchet@debian.org>  Fri, 31 Jan 2025 16:00:56 +0100

=== debian/control ===
Source: simutrans
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Clint Adams <clint@debian.org>,
 Jörg Frings-Fürst <debian@jff.email>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libbz2-dev,
 libfluidsynth-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libminiupnpc-dev,
 libpng-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libzstd-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.simutrans.com/
Vcs-Git: https://salsa.debian.org/games-team/simutrans.git
Vcs-Browser: https://salsa.debian.org/games-team/simutrans
X-Style: black

Package: simutrans
Architecture: any
Depends:
 simutrans-data (= ${source:Version}),
 simutrans-pak64 (>= 121.0),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 freepats,
Description: transportation simulator
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.

Package: simutrans-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: transportation simulator (base data)
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the base data.

Package: simutrans-makeobj
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: data file compiler for Simutrans
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the makeobj program needed to integrate new objects
 in Simutrans.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules file for simutrans

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export VERBOSE  = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
TODAY=$(shell env LC_TIME=C.utf8 date --utc --date=@${SOURCE_DATE_EPOCH} +"%Y-%m-%d")
SIMUTRANS_REVISION=386

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=/usr/games -DSIMUTRANS_USE_REVISION=${SIMUTRANS_REVISION} -DUSE_GAMES_DATADIR=1
	sed -e "s/@TODAY@/${TODAY}/g" -e "s/@SIMUTRANS_WC_REVISION@/${SIMUTRANS_REVISION}/g" -e "s/@ver_major@.@ver_minor@.@ver_patch@@nightly_suffix@/${DEB_VERSION_UPSTREAM}/g" $(CURDIR)/src/linux/com.simutrans.Simutrans.metainfo.xml.in > $(CURDIR)/src/linux/com.simutrans.Simutrans.metainfo.xml

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- makeobj
	#dh_auto_build -- nettool

override_dh_auto_test:

override_dh_installchangelogs:
	dh_installchangelogs simutrans/history.txt

update-translations:
	dh_testdir
	wget --post-data "version=0&choice=all&submit=Export!" --delete-after "http://simutrans-germany.com/translator/script/main.php?page=wrap"
	wget -N http://simutrans-germany.com/translator/data/tab/language_pack-Base+texts.zip
	unzip -o -d debian/translations language_pack-Base+texts.zip "*.tab"
	$(RM) language_pack-Base+texts.zip

=== debian/watch ===
version=4
https://github.com/simutrans/@PACKAGE@/tags .*/v?(\d.*)@ARCHIVE_EXT@
